"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportEventQuestionnaireRD(ProtocolElement):
    """
    The report event for a questionnaire in RD.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "familyLevelQuestions",
        "variantGroupLevelQuestions",
        "variantLevelQuestions",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "familyLevelQuestions": reports_6_4_0.FamilyLevelQuestions,
            "variantGroupLevelQuestions": reports_6_4_0.VariantGroupLevelQuestions,
            "variantLevelQuestions": reports_6_4_0.VariantLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import cva as cva_1_5_3
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.FamilyLevelQuestions": reports_6_4_0.FamilyLevelQuestions,
            "org.gel.models.report.avro.VariantGroupLevelQuestions": reports_6_4_0.VariantGroupLevelQuestions,
            "org.gel.models.report.avro.VariantLevelQuestions": reports_6_4_0.VariantLevelQuestions,
            "org.gel.models.cva.avro.ReportEventQuestionnaireRD": cva_1_5_3.ReportEventQuestionnaireRD,
        }

    __slots__ = [
        "familyLevelQuestions",
        "variantGroupLevelQuestions",
        "variantLevelQuestions",
        "groupOfVariants",
    ]

    def __init__(
        self,
        familyLevelQuestions,
        variantGroupLevelQuestions,
        variantLevelQuestions,
        groupOfVariants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.ReportEventQuestionnaireRD model.

        :param familyLevelQuestions:
            The family level questions
        :type familyLevelQuestions: FamilyLevelQuestions
        :param variantGroupLevelQuestions:
            The variant group level questions
        :type variantGroupLevelQuestions: VariantGroupLevelQuestions
        :param variantLevelQuestions:
            The variant level questions
        :type variantLevelQuestions: VariantLevelQuestions
        :param groupOfVariants:
            The identifier used to group variants together
        :type groupOfVariants: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
